"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var fs=require("fs"),path=require("path"),resolve=_interopDefault(require("resolve")),prettier=require("prettier"),logger=_interopDefault(require("signale")),fs$1=require("fs-extra"),artTemplate=require("art-template"),ulid=require("ulid"),vfile=_interopDefault(require("to-vfile")),unified=_interopDefault(require("unified")),remark=_interopDefault(require("remark-parse")),matter=_interopDefault(require("remark-frontmatter")),slug=_interopDefault(require("remark-slug")),parseFrontmatter=_interopDefault(require("remark-parse-yaml")),slugify=_interopDefault(require("@sindresorhus/slugify")),find=_interopDefault(require("unist-util-find")),is=_interopDefault(require("unist-util-is")),visit=_interopDefault(require("unist-util-visit")),get=_interopDefault(require("lodash.get")),humanize=_interopDefault(require("humanize-string")),glob=require("fast-glob"),loadCfg=require("load-cfg"),chokidar=_interopDefault(require("chokidar")),WS=_interopDefault(require("ws")),merge=_interopDefault(require("deepmerge")),remove=_interopDefault(require("unist-util-remove")),babylon=require("babylon"),traverse=_interopDefault(require("babel-traverse")),nodeToString=_interopDefault(require("hast-util-to-string")),strip=_interopDefault(require("strip-indent")),slug$1=_interopDefault(require("rehype-slug")),headings=_interopDefault(require("rehype-autolink-headings")),HappyPack=_interopDefault(require("happypack")),webpackBarPlugin=_interopDefault(require("webpackbar")),Config=_interopDefault(require("webpack-chain")),friendlyErrors=_interopDefault(require("friendly-errors-webpack-plugin")),htmlWebpackPlugin=_interopDefault(require("html-webpack-plugin")),manifestPlugin=_interopDefault(require("webpack-manifest-plugin")),UglifyJs=_interopDefault(require("uglifyjs-webpack-plugin")),mount=_interopDefault(require("koa-mount")),range=_interopDefault(require("koa-range")),convert=_interopDefault(require("koa-connect")),serveStatic=_interopDefault(require("koa-static")),history=_interopDefault(require("connect-history-api-fallback")),serveWaitpage=_interopDefault(require("webpack-serve-waitpage")),serve=_interopDefault(require("webpack-serve")),chalk=_interopDefault(require("chalk")),webpack=_interopDefault(require("webpack")),FSR=_interopDefault(require("react-dev-utils/FileSizeReporter")),formatWebpackMessages=_interopDefault(require("react-dev-utils/formatWebpackMessages")),printBuildError=_interopDefault(require("react-dev-utils/printBuildError")),detectPort=_interopDefault(require("detect-port")),titleize=_interopDefault(require("titleize"));const ensureSlash=(e,t)=>{const r=e.endsWith("/");return r&&!t?e.substr(e,e.length-1):!r&&t?`${e}/`:e},root=fs.realpathSync(process.cwd()),resolveApp=e=>path.resolve(root,e),resolveOwn=e=>path.resolve(__dirname,"../",e),templates=path.join(resolve.sync("docz-core"),"../templates"),packageJson=resolveApp("package.json"),servedPath=e=>ensureSlash(e,!0),docz=resolveApp(".docz"),app=path.resolve(docz,"app/"),appPublic=path.resolve(docz,"public/"),appNodeModules=resolveApp("node_modules"),ownNodeModules=resolveOwn("node_modules"),getDist=e=>path.join(root,e),distPublic=e=>path.join(e,"public/"),importsJs=path.resolve(app,"imports.js"),rootJs=path.resolve(app,"root.jsx"),indexJs=path.resolve(app,"index.jsx"),indexHtml=path.resolve(app,"index.html"),entriesJson=path.resolve(app,"entries.json"),configJson=path.resolve(app,"config.json");var paths=Object.freeze({root:root,templates:templates,packageJson:packageJson,servedPath:servedPath,docz:docz,app:app,appPublic:appPublic,appNodeModules:appNodeModules,ownNodeModules:ownNodeModules,getDist:getDist,distPublic:distPublic,importsJs:importsJs,rootJs:rootJs,indexJs:indexJs,indexHtml:indexHtml,entriesJson:entriesJson,configJson:configJson});function __rest(e,t){var r={};for(var s in e)Object.prototype.hasOwnProperty.call(e,s)&&0>t.indexOf(s)&&(r[s]=e[s]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var i=0;for(s=Object.getOwnPropertySymbols(e);s.length>i;i++)0>t.indexOf(s[i])&&(r[s[i]]=e[s[i]])}return r}const format=e=>new Promise((t,r)=>{try{t(prettier.format(e,{parser:"babylon",semi:!1,singleQuote:!0,trailingComma:"all"}))}catch(e){logger.fatal(e),t(e)}}),touch=(e,t)=>new Promise(async(r,s)=>{const i=/jsx?$/.test(path.extname(e))?await format(t):t,o=fs$1.createWriteStream(e);o.write(i,"utf-8"),o.on("finish",()=>r()),o.on("error",e=>s(e)),o.end()}),read=e=>new Promise((t,r)=>{let s="";const i=fs$1.createReadStream(e,{encoding:"utf-8"});i.on("data",e=>s+=e),i.on("end",()=>t(s)),i.on("error",e=>r(e))}),compiled=async e=>read(e).then(e=>artTemplate.compile(e)).catch(e=>e),{keys:keys}=Object,isFn=e=>"function"==typeof e;function omit(e,t){return keys(t).filter(t=>-1===e.indexOf(t)).reduce((e,r)=>Object.assign({},e,{[r]:t[r]}),{})}const mapToObj=e=>Array.from(e.entries()).reduce((e,[t,r])=>Object.assign({},e,{[`${t}`]:r}),{}),parseMdx=e=>{const t=vfile.readSync(e,"utf-8"),r=unified().use(remark,{type:"yaml",marker:"-"}).use(matter).use(parseFrontmatter).use(slug);return r.run(r.parse(t))},getParsedData=e=>{const t=find(e,e=>is("yaml",e));return get(t,"data.parsedValue")||{}},getHeadings=e=>{const t=[];return visit(e,"heading",e=>{const r=get(e,"data.id"),s=get(e,"depth");t.push({depth:s,slug:r,value:humanize(r)})}),t};class Entry{constructor(e,t,r){const s=this.getFilepath(t,r),i=getParsedData(e),o=this.getName(s,i);this.id=ulid.ulid(),this.filepath=s,this.slug=this.slugify(s),this.route=this.getRoute(i),this.name=o,this.order=i.order||0,this.menu=i.menu||null,this.headings=getHeadings(e),this.settings=i}getFilepath(e,t){const r=path.resolve(root,t),s=path.relative(r,e);return"win32"===process.platform?s.split("\\").join("/"):s}getName(e,t){const r=humanize(path.parse(e).name);return t&&t.name?t.name:r}slugify(e){const t=path.extname(e),r=e.replace(t,"");return slugify(r)}getRoute(e){return e&&e.route?e.route:`/${this.slug}`}}class Plugin{constructor(e){this.setConfig=e.setConfig,this.modifyBundlerConfig=e.modifyBundlerConfig,this.modifyBabelRc=e.modifyBabelRc,this.onCreateApp=e.onCreateApp,this.onServerListening=e.onServerListening,this.onPreBuild=e.onPreBuild,this.onPostBuild=e.onPostBuild,this.onPreRender=e.onPreRender,this.onPostRender=e.onPostRender}static runPluginsMethod(e){return(t,...r)=>{if(e&&e.length>0)for(const s of e){const e=get(s,t);isFn(e)&&e(...r)}}}static propsOfPlugins(e){return t=>e&&e.length>0&&e.map(e=>get(e,t)).filter(e=>e)}static reduceFromPlugins(e){return(t,r,...s)=>[...e||[]].reduce((e,r)=>{const i=get(r,t);return i&&isFn(i)?i(e,...s):e},r)}}function createPlugin(e){return new Plugin(e)}const fromTemplates=e=>path.join(templates,e),getHtmlFilepath=e=>e?path.join(root,e):fromTemplates("index.tpl.html"),getPublicUrl=(e,t)=>{const r="/"===e.base?"":e.base;return t?r:`${r}/public`},writeAppFiles=async(e,t)=>{const{plugins:r,title:s,description:i,theme:o,indexHtml:n}=e,a=Plugin.propsOfPlugins(r),l=a("onPreRender"),p=a("onPostRender"),u=await compiled(fromTemplates("root.tpl.js")),c=await compiled(fromTemplates("index.tpl.js")),d=await compiled(getHtmlFilepath(n)),g=u({theme:o,isProd:!t,wrapper:e.wrapper,hashRouter:e.hashRouter,websocketUrl:`ws://${e.websocketHost}:${e.websocketPort}`}),m=c({onPreRenders:l,onPostRenders:p}),f=d({title:s,description:i,publicUrl:getPublicUrl(e,t)});await touch(rootJs,g),await touch(indexJs,m),await touch(indexHtml,f)},writeImports=async e=>{const t=(await compiled(fromTemplates("imports.tpl.js")))({entries:Object.values(e)});await touch(importsJs,t)},writeData=async(e,t)=>{const r=Object.assign({title:t.title,description:t.description},t.themeConfig);await touch(entriesJson,JSON.stringify(e,null,2)),await touch(configJson,JSON.stringify(r,null,2))};class Entries{static async writeApp(e,t){await fs$1.ensureDir(app),await writeAppFiles(e,!!t)}static async writeImports(e){await writeImports(e)}static async writeData(e,t){await writeData(e,t)}constructor(e){this.all=new Map,this.get=(async()=>this.getMap(e))}async getMap(e){const{src:t,files:r}=e,s=glob.sync(Array.isArray(r)?[...r,"!node_modules"]:[r,"!node_modules"]),i=new Map,o=await Promise.all(s.map(async e=>{const r=await parseMdx(e),s=new Entry(r,e,t),{settings:i}=s,o=__rest(s,["settings"]);return Object.assign({},i,o)}));for(const e of o)i.set(e.filepath,e);return this.all=i,mapToObj(i)}}const isSocketOpened=e=>e.readyState===WS.OPEN;class DataServer{constructor({server:e,config:t}){this.config=t,this.server=new WS.Server({server:e,port:t.websocketPort,host:t.websocketHost})}async processEntries(e){const t=chokidar.watch(this.config.files,{ignored:/(^|[\/\\])\../});this.server.on("connection",async r=>{const s=this.updateEntries(e,r),i=await e.get();t.on("change",async()=>s(this.config)),t.on("unlink",async()=>s(this.config)),t.on("raw",async(e,t,r)=>{"moved"===r.event&&"directory"===r.type&&await s(this.config)}),r.send(this.entriesData(i)),await Entries.writeImports(i)}),this.server.on("close",()=>t.close())}async processThemeConfig(){const e=chokidar.watch(loadCfg.finds("docz"));this.server.on("connection",async t=>{const r=this.updateConfig(t);e.on("add",()=>r()),e.on("change",()=>r()),e.on("unlink",()=>r()),r()}),this.server.on("close",()=>e.close())}dataObj(e,t){return JSON.stringify({type:e,data:t})}entriesData(e){return this.dataObj("docz.entries",e)}configData(e){return this.dataObj("docz.config",Object.assign({},e.themeConfig,{title:e.title,description:e.description,ordering:e.ordering}))}updateEntries(e,t){return async r=>{if(isSocketOpened(t)){const r=await e.get();await Entries.writeImports(r),t.send(this.entriesData(r))}}}updateConfig(e){const t={title:this.config.title,description:this.config.description,themeConfig:this.config.themeConfig,ordering:this.config.ordering};return()=>{const r=loadCfg.load("docz",t,!0);isSocketOpened(e)&&e.send(this.configData(r))}}}const getPresets=e=>{const t=[[require.resolve("babel-preset-react-app"),{flow:!e.typescript}]];return e.typescript&&t.push(require.resolve("@babel/preset-typescript")),t},getPlugins=(e,t)=>{const r=[];return"production"===t||r.push(require.resolve("react-hot-loader/babel")),e.propsParser&&!e.typescript&&r.push([require.resolve("babel-plugin-react-docgen"),{resolver:"findAllExportedComponentDefinitions"}]),r},babelrc=(e,t)=>{const r=getPresets(e),s=getPlugins(e,t),i=merge(loadCfg.load("babel",null),{presets:r,plugins:s,cacheDirectory:!e.debug,babelrc:!1}),o=Plugin.reduceFromPlugins(e.plugins)("modifyBabelRc",i,e);return e.modifyBabelRc(o,e)};class Bundler{constructor(e){const{args:t,config:r,server:s,build:i}=e;this.args=t,this.config=r,this.server=s,this.builder=i}getConfig(e){const t=babelrc(this.args,e),r=this.mountConfig(this.config(t));return this.args.modifyBundlerConfig(r,!this.isProd(),this.args)}async createServer(e){const t=Plugin.runPluginsMethod(this.args.plugins);return this.server(e,{onCreateApp(e){t("onCreateApp",e)},OnServerListening(e){t("onServerListening",e)}})}async build(e){const t=getDist(this.args.dest);root===path.resolve(t)&&(logger.fatal(Error('Unexpected option: "dest" cannot be set to the current working directory.')),process.exit(1)),await this.builder(e,t)}mountConfig(e){const{plugins:t}=this.args;return Plugin.reduceFromPlugins(t)("modifyBundlerConfig",e,!this.isProd(),this.args)}isProd(){return"production"===process.env.NODE_ENV}}const componentName=e=>{const t=e.match(/^\<\\?(\w+)/);return t&&t[1]},valuesFromNodes=e=>(t,r)=>{const s=[];if(t!==r)for(let i=r;i>=t;i--){const r=e.children[i];r.children&&r.children.length>0&&s.push(...r.children.map(e=>e.value)),r.value&&r.value.length>0&&s.push(r.value),i!==t&&remove(e,r)}return s},mergeNodeWithoutCloseTag=(e,t,r)=>{if(!t.value||"string"!=typeof t.value)return;const s=componentName(t.value),i=RegExp(`^\\<${s}`),o=RegExp(`\\<\\/${s}\\>$`),n=e=>i.test(e),a=e=>o.test(e),l=e=>e&&!n(e)&&a(e);if(!s||n(t.value)&&a(t.value))return;const p=e.children.findIndex(({value:e,children:t})=>t?t.some(e=>l(e.value)):l(e));if(p>-1&&p!==r){const s=valuesFromNodes(e)(r,p);t.value=s.reverse().join("\n")}},plugin=()=>e=>{visit(e,"html",function(t,r){mergeNodeWithoutCloseTag(e,t,r)})},codeFromNode=e=>t=>{let r="";const s=babylon.parse(t,{plugins:["jsx"]});return traverse(s,{enter(s){if(e(s))return r=t.slice(s.node.start,s.node.end),void s.stop()}}),r},componentName$1=e=>{const t=e.match(/^\<\\?(\w+)/);return t&&t[1]},isPlayground=e=>"Playground"===e,isOpenTag=e=>e.isJSXOpeningElement()&&isPlayground(e.node.name.name),isClosetag=e=>e.isJSXClosingElement()&&isPlayground(e.node.name.name),removePlayground=e=>{const t=codeFromNode(isOpenTag),r=codeFromNode(isClosetag);return e.replace(t(e),"").replace(r(e),"")},addCodeProp=async e=>{const t=componentName$1(e.value),r=RegExp(`^\\<${t}`);if(isPlayground(t)){const s=(await format(nodeToString(e))).slice(1,1/0),i=strip(removePlayground(s)).trim();e.value=e.value.replace(r,`<${t} __code={${`(components) => components && (\n      <components.pre className="react-prism language-jsx">\n        <code>{\`${i}\`}</code>\n      </components.pre>\n    )`}}`)}},plugin$1=()=>(e,t)=>{const r=[e.children.filter(e=>is("jsx",e)).map(async function(e){await addCodeProp(e)})];return Promise.all(r).then(()=>e)},config={type:"yaml",marker:"-",properties:{"aria-hidden":!0},content:{type:"element",tagName:"span",properties:{className:["icon-link"]},children:[{type:"text",value:"#"}]}},remarkPlugins=[matter,plugin],rehypePlugins=[plugin$1,slug$1,headings],setupHappypack=(e,t,r)=>{const s={id:"jsx",verbose:t.debug,loaders:[{loader:require.resolve("babel-loader"),options:r}]};t.propsParser&&t.typescript&&s.loaders.push({loader:require.resolve("react-docgen-typescript-loader")});const i={id:"mdx",verbose:t.debug,loaders:[{loader:require.resolve("babel-loader"),options:Object.assign({},r,{plugins:r.plugins.filter(e=>/react\-hot\-loader\/babel/.test(e)).filter(e=>/babel\-plugin\-react\-docgen/.test(e))})}]};e.plugin("happypack-jsx").use(HappyPack,[s]),e.plugin("happypack-mdx").use(HappyPack,[i])},js=(e,t)=>{const r=path.resolve(root,t.src);e.module.rule("js").test(/\.(js|jsx|mjs)$/).include.add(r).add(docz).end().exclude.add(/node_modules/).end().use("happypack-jsx").loader("happypack/loader?id=jsx")},ts=(e,t)=>{const r=path.resolve(root,t.src);e.module.rule("ts").test(/\.(ts|tsx)$/).include.add(r).end().exclude.add(/node_modules/).end().use("happypack-jsx").loader("happypack/loader?id=jsx")},mdx=(e,t)=>{const{mdPlugins:r,hastPlugins:s}=t,i=path.resolve(root,t.src);e.module.rule("mdx").test(/\.md?x$/).include.add(i).end().exclude.add(/node_modules/).end().use("happypack-mdx").loader("happypack/loader?id=mdx").end().use("mdx-loader").loader(require.resolve("@mdx-js/loader")).options(Object.assign({},config,{mdPlugins:r.concat(remarkPlugins),hastPlugins:s.concat(rehypePlugins)}))},INLINE_LIMIT=1e4,images=e=>{e.module.rule("images").test(/\.(png|jpe?g|gif)(\?.*)?$/).use("url-loader").loader(require.resolve("url-loader")).options({limit:1e4,name:"static/img/[name].[hash:8].[ext]"})},svg=e=>{e.module.rule("svg").test(/\.(svg)(\?.*)?$/).use("file-loader").loader(require.resolve("file-loader")).options({name:"static/img/[name].[hash:8].[ext]"})},media=e=>{e.module.rule("media").test(/\.(mp4|webm|ogg|mp3|wav|flac|aac)(\?.*)?$/).use("url-loader").loader(require.resolve("url-loader")).options({limit:1e4,name:"static/media/[name].[hash:8].[ext]"})},fonts=e=>{e.module.rule("fonts").test(/\.(woff2?|eot|ttf|otf)(\?.*)?$/i).use("url-loader").loader(require.resolve("url-loader")).options({limit:1e4,name:"static/fonts/[name].[hash:8].[ext]"})},uglify=new UglifyJs({parallel:!0,cache:!0,sourceMap:!0,uglifyOptions:{parse:{ecma:8},compress:{ecma:5,warnings:!1,comparisons:!1},mangle:{safari10:!0},output:{ecma:5,comments:!1,ascii_only:!0}}}),createConfig=(e,t)=>r=>{const{debug:s,host:i,port:o,protocol:n}=e,a=new Config,l="production"===t,p=servedPath(e.base),u=getDist(e.dest),c=path.resolve(root,e.src);a.context(root),a.set("mode",t),a.when(s,e=>e.devtool("source-map")),a.when(!l,e=>e.devtool("cheap-module-eval-source-map")),a.node.merge({child_process:"empty",dgram:"empty",fs:"empty",net:"empty",tls:"empty"});a.output.pathinfo(!0).path(u).publicPath(l?p:"/").when(l,e=>e.filename("static/js/[name].[hash].js").sourceMapFilename("static/js/[name].[hash].js.map").chunkFilename("static/js/[name].[chunkhash:8].js"),e=>e.filename("static/js/[name].js").sourceMapFilename("static/js/[name].js.map")).crossOriginLoading("anonymous"),a.merge({optimization:Object.assign({nodeEnv:t,namedModules:!0,noEmitOnErrors:!0,runtimeChunk:!0,splitChunks:{chunks:"all",name:"vendors"}},l&&{minimize:!0,minimizer:[uglify]})}),a.entry("app").add(require.resolve("babel-polyfill")).add(indexJs),a.resolve.set("symlinks",!0).alias.set("@babel/runtime",path.dirname(require.resolve("@babel/runtime/package.json")));const d=t=>{t.extensions.add(".web.js").add(".mjs").add(".js").add(".json").add(".web.jsx").add(".jsx").add(".mdx").end(),e.typescript&&t.extensions.prepend(".ts").prepend(".tsx").end()};d(a.resolve),d(a.resolveLoader),a.resolve.modules.add(ownNodeModules).add(appNodeModules).add("node_modules").add(c).add(root),a.resolveLoader.set("symlinks",!0).modules.add(ownNodeModules).add(appNodeModules).add("node_modules").add(root),js(a,e),mdx(a,e),e.typescript&&ts(a,e),setupHappypack(a,e,r),images(a),svg(a),media(a),fonts(a),a.plugin("assets-plugin").use(manifestPlugin,[{filename:"assets.json"}]),a.plugin("html-webpack-plugin").use(htmlWebpackPlugin,[Object.assign({inject:!0,template:indexHtml},l&&{minify:{removeComments:!0,collapseWhitespace:!0,removeRedundantAttributes:!0,useShortDoctype:!0,removeEmptyAttributes:!0,removeStyleLinkTypeAttributes:!0,keepClosingSlash:!0,minifyJS:!0,minifyCSS:!0,minifyURLs:!0}})]);const g="127.0.0.1"===i||"0.0.0.0"===i?"localhost":i;return a.when(!s&&!l,e=>{e.plugin("webpackbar").use(webpackBarPlugin,[{color:"#41b883",compiledIn:!1,name:"Client"}]),e.plugin("friendly-errors").use(friendlyErrors,[{compilationSuccessInfo:{messages:[`Your application is running at ${n}://${g}:${o}`]}}])}),a.plugin("injections").use(require("webpack/lib/DefinePlugin"),[{BASE_URL:JSON.stringify(p),NODE_ENV:JSON.stringify(t)}]),a.performance.hints(!1),a.toConfig()},devServerConfig=(e,t,r)=>{const s=path.resolve(__dirname,"non-existent"),i=t=>e.debug?"debug":t;return{config:t,host:e.host,port:e.port,content:[s],logLevel:i("error"),devMiddleware:{logLevel:i("silent")},hotClient:{reload:!1,logLevel:i("error")},add:(t,s,i)=>{s.webpack(),s.content(),t.use(range),fs$1.existsSync(appPublic)&&t.use(mount(e.base,serveStatic(appPublic))),t.use(convert(history({rewrites:[{from:/\.html$/,to:"/"}]}))),t.use(serveWaitpage(i,{title:e.title})),r.onCreateApp(t)}}},server=e=>async(t,r)=>{const s=devServerConfig(e,t,r);return{start:async()=>{const e=await serve({},s);return r.OnServerListening(e.app.server),Object.assign({},e,{close:()=>e.app.stop()})}}};process.env.BABEL_ENV=process.env.BABEL_ENV||"production",process.env.NODE_ENV=process.env.NODE_ENV||"production";const{measureFileSizesBeforeBuild:measureFileSizesBeforeBuild,printFileSizesAfterBuild:printFileSizesAfterBuild}=FSR,WARN_AFTER_BUNDLE_GZIP_SIZE=524288,WARN_AFTER_CHUNK_GZIP_SIZE=1048576,hasCiEnvVar=()=>process.env.CI&&("string"!=typeof process.env.CI||"false"!==process.env.CI.toLowerCase()),copyPublicFolder=async e=>{await fs$1.pathExists(appPublic)&&await fs$1.copySync(appPublic,distPublic(e),{dereference:!0,filter:e=>e!==indexHtml})},compile=e=>new Promise((t,r)=>{let s;try{s=webpack(e)}catch(e){onError(e)}s&&s.run((e,s)=>{e&&r(e),t(s)})}),builder=async(e,t)=>(logger.start("Creating an optimized production build..."),new Promise(async(r,s)=>{try{const i=await compile(e),o=formatWebpackMessages(i.toJson({},!0));return o.errors.length?s(Error(o.errors.join("\n\n"))):hasCiEnvVar()&&o.warnings.length?(logger.warn("\nTreating warnings as errors because process.env.CI = true.\nMost CI servers set it automatically.\n"),s(Error(o.warnings.join("\n\n")))):r({stats:i,previousFileSizes:t,warnings:o.warnings})}catch(e){s(e)}})),onSuccess=(e,{stats:t,previousFileSizes:r,warnings:s})=>{s.length?(logger.warn("Compiled with warnings.\n"),logger.warn(s.join("\n\n")),logger.warn("\nSearch for the "+chalk.underline(chalk.yellow("keywords"))+" to learn more about each warning."),logger.warn("To ignore, add "+chalk.cyan("// eslint-disable-next-line")+" to the line before.\n")):logger.success(chalk.green("Compiled successfully.\n")),logger.log("File sizes after gzip:\n"),printFileSizesAfterBuild(t,r,e,524288,1048576),logger.log()},onError=e=>{logger.fatal(chalk.red("Failed to compile.\n")),printBuildError(e),process.exit(1)},build=async(e,t)=>{try{await fs$1.ensureDir(t);const r=await measureFileSizesBeforeBuild(t);await fs$1.emptyDir(t),await copyPublicFolder(t);const s=await builder(e,r);onSuccess(t,s)}catch(e){onError(e)}},bundler=(e,t)=>new Bundler({args:e,build:build,config:createConfig(e,t),server:server(e)}),toOmit=["_","$0","version","help"],loadConfig=e=>{const t=loadCfg.load("docz",Object.assign({},e,{paths:paths,hashRouter:!1,plugins:[],mdPlugins:[],hastPlugins:[],themeConfig:{},modifyBundlerConfig:e=>e,modifyBabelRc:e=>e})),r=Plugin.reduceFromPlugins(t.plugins);return omit(toOmit,r("setConfig",t))};process.env.BABEL_ENV="development",process.env.NODE_ENV="development";const env=process.env.NODE_ENV,dev=async e=>{const t=loadConfig(e),r=await detectPort(t.port),s=await detectPort(t.websocketPort),i=new Entries(t),o=bundler(Object.assign({},t,{port:r}),env),n=await o.createServer(o.getConfig(env)),{app:a}=await n.start(),l=Object.assign({},t,{websocketPort:s}),p=new DataServer({server:a.server,config:l});try{logger.info("Removing old app files"),await fs$1.remove(app),logger.info("Creating boilerplate files"),await Entries.writeApp(l,!0),await Entries.writeImports(await i.get()),logger.info(`Setup entries websockets server on port ${s}`),await p.processEntries(i),await p.processThemeConfig()}catch(e){logger.fatal("Failed to process your server:",e),process.exit(1)}};process.env.BABEL_ENV="production",process.env.NODE_ENV="production";const env$1=process.env.NODE_ENV,build$1=async e=>{const t=loadConfig(e),r=bundler(t,env$1),s=new Entries(t),i=await s.get(),o=Plugin.runPluginsMethod(t.plugins);await fs$1.remove(app),await Entries.writeApp(t),await Entries.writeImports(i),await Entries.writeData(i,t);try{await o("onPreBuild"),await r.build(r.getConfig(env$1)),await o("onPostBuild")}catch(e){logger.fatal(e),process.exit(1)}},removeScope=e=>e.replace(/^@.*\//,""),getInitialTitle=()=>{const e=fs$1.readJsonSync(packageJson,{throws:!1});return titleize(humanize(removeScope(e&&e.name?e.name:"MyDoc")))},args=e=>{e.positional("base",{type:"string",default:"/"}),e.positional("source",{alias:"src",type:"string",default:"./"}),e.positional("files",{type:"string",default:"**/*.mdx"}),e.positional("dest",{alias:"d",type:"string",default:".docz/dist"}),e.positional("title",{type:"string",default:getInitialTitle()}),e.positional("description",{type:"string",default:"My awesome app using Docz"}),e.positional("theme",{type:"string",default:"docz-theme-default"}),e.positional("typescript",{alias:"ts",type:"boolean",default:!1}),e.positional("propsParser",{type:"boolean",default:!0}),e.positional("wrapper",{type:"string"}),e.positional("indexHtml",{type:"string"}),e.positional("ordering",{type:"string",default:"descending"}),e.positional("debug",{type:"boolean",default:process.env.DEBUG||!1}),e.positional("protocol",{type:"string",default:"true"===process.env.HTTPS?"https":"http"}),e.positional("host",{type:"string",default:process.env.HOST||"127.0.0.1"}),e.positional("port",{alias:"p",type:"number",default:process.env.PORT||3e3}),e.positional("websocketHost",{type:"string",default:process.env.WEBSOCKET_HOST||"127.0.0.1"}),e.positional("websocketPort",{type:"number",default:process.env.WEBSOCKET_PORT||8089})};var index=Object.freeze({dev:dev,build:build$1,args:args});exports.commands=index,exports.Plugin=Plugin,exports.createPlugin=createPlugin;
